-- BagInfosToolTip.lua
-- written by Habna


local player = Turbine.Gameplay.LocalPlayer.GetInstance();
local backpack = player:GetBackpack();
local size = backpack:GetSize();

-- Legend
-- ( offsetX, offsetY, width, height, bubble side, mouseX, mouseY )
function ShowBIWindow()
	max, iFound = 0, 0;

	for i = 1, #ITL do
		for k,v in pairs(ITL[i]) do
			for ii = 1, size do
				local item = backpack:GetItem( ii );
				if item ~= nil then
					if k == item:GetName() then
						max = max + 1;
						iFound = iFound + 1; -- Count entry in item tracking list so we can calculate the height needed to set tooltip height
						break
					end
				end
			end
		end
	end

	if iFound == 0 then max = 1; w = 250; else w = 325; end --If no item beeing track, set max to 1 to size tooltip with the no item message
	local x, y, w, h, bblTo = -5, -10, w, (max * 35) + 30, "left";
	local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
	
	if w + mouseX > screenWidth then bblTo = "right"; x = w - 10; end
	if not TBTop then y = h + 5; end
	TTW = CreateBIWindow( x, y, w, h, bblTo, mouseX, mouseY );
end

function CreateBIWindow( xOffset, yOffset, xSize, ySize, side, mX, mY )
	_G.ToolTipWin = Turbine.UI.Window();
	_G.ToolTipWin:SetSize( xSize, ySize );
	_G.ToolTipWin:SetZOrder( 1 );
	_G.ToolTipWin.xOffset = xOffset;
	_G.ToolTipWin.yOffset = yOffset;
	_G.ToolTipWin:SetPosition( mX - xOffset, mY - yOffset);
	_G.ToolTipWin:SetVisible( true );

	--**v Top left corner v**
	topLeftCorner = Turbine.UI.Control();
	topLeftCorner:SetParent( _G.ToolTipWin );
	topLeftCorner:SetPosition( 0, 0 );
	topLeftCorner:SetSize( 15, 12 );
	topLeftCorner:SetBackground( resources.Bubble_TopLeftCorner.Background );
	--**^
	--**v Mid Left v**
	midLeft = Turbine.UI.Control();
	midLeft:SetParent( _G.ToolTipWin );
	midLeft:SetPosition( 0, 12 );
	midLeft:SetSize( 15, _G.ToolTipWin:GetHeight() - 12 );
	midLeft:SetBackground( resources.Bubble_MidLeft.Background );
	--**^
	--**v Bottom Left Corner v**
	botLeftCorner = Turbine.UI.Control();
	botLeftCorner:SetParent( _G.ToolTipWin );
	botLeftCorner:SetPosition( 0, _G.ToolTipWin:GetHeight() - 12 );
	botLeftCorner:SetSize( 15, 12 );
	botLeftCorner:SetBackground( resources.Bubble_BotLeftCorner.Background );
	--**^
	--**v Top v**
	TopBar = Turbine.UI.Control();
	TopBar:SetParent( _G.ToolTipWin );
	TopBar:SetPosition( 15, 0 );
	TopBar:SetSize( _G.ToolTipWin:GetWidth() - 15, 12 );
	TopBar:SetBackground( resources.Bubble_Top.Background );
	--**^
	--**v Middle v**
	MidMid = Turbine.UI.Control();
	MidMid:SetParent( _G.ToolTipWin );
	MidMid:SetPosition( 15, 12 );
	MidMid:SetSize( _G.ToolTipWin:GetWidth() - 15, _G.ToolTipWin:GetHeight() - 12 );
	MidMid:SetBackground( resources.Bubble_Mid.Background );
	--**^
	--**v Bottom v**
	BotBar = Turbine.UI.Control();
	BotBar:SetParent( _G.ToolTipWin );
	BotBar:SetPosition( 15, _G.ToolTipWin:GetHeight() - 12 );
	BotBar:SetSize( _G.ToolTipWin:GetWidth() - 5, 12 );
	BotBar:SetBackground( resources.Bubble_Bot.Background );
	--**^
	--**v Top right corner v**
	topRightCorner = Turbine.UI.Control();
	topRightCorner:SetParent( _G.ToolTipWin );
	topRightCorner:SetPosition( _G.ToolTipWin:GetWidth() - 15, 0 );
	topRightCorner:SetSize( 15, 12 );
	topRightCorner:SetBackground( resources.Bubble_TopRightCorner.Background );
	--**^
	--**v Mid Right v**
	midRight = Turbine.UI.Control();
	midRight:SetParent( _G.ToolTipWin );
	midRight:SetPosition( _G.ToolTipWin:GetWidth() - 15, 12 );
	midRight:SetSize( 15, _G.ToolTipWin:GetHeight() - 12 );
	midRight:SetBackground( resources.Bubble_MidRight.Background );
	--**^
	--**v Bottom right corner v**
	botRightCorner = Turbine.UI.Control();
	botRightCorner:SetParent( _G.ToolTipWin );
	botRightCorner:SetPosition( _G.ToolTipWin:GetWidth() - 15, _G.ToolTipWin:GetHeight() - 12 );
	botRightCorner:SetSize( 15, 12 );
	botRightCorner:SetBackground( resources.Bubble_BotRightCorner.Background );
	--**^
	
	BITTListBox = Turbine.UI.ListBox();
	BITTListBox:SetParent( _G.ToolTipWin );
	BITTListBox:SetPosition( 20, 17 );
	BITTListBox:SetWidth( _G.ToolTipWin:GetWidth() - 40 );
	BITTListBox:SetMaxItemsPerLine( 1 );
	BITTListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	--BITTListBox:SetBackColor( Color["darkgrey"] ); --debug purpose

	BIRefreshListBox();

	return _G.ToolTipWin;
end

function BIRefreshListBox()
	BITTListBox:ClearItems();
	BITTPosY = 35;
	
	if iFound == 0 then
		--**v Profil name v**
		local lblName = Turbine.UI.Label();
		lblName:SetParent( _G.ToolTipWin );
		--lblName:SetFont ( 12 );
		lblName:SetText( L["BINI"] );
		lblName:SetPosition( 0, 0 );
		lblName:SetSize( _G.ToolTipWin:GetWidth()-40, 35 );
		lblName:SetForeColor( Color["green"] );
		lblName:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		--lblName:SetBackColor( Color["red"] ); -- debug purpose
		--**^

		BITTListBox:AddItem( lblName );

		BITTPosY = BITTPosY + 35;
	else
		for i = 1, #ITL do
			for k,v in pairs(ITL[i]) do
				BITTItemTot = 0;
				for ii = 1, size do
					local bFound = false;
					local item = backpack:GetItem( ii );
				
					if item ~= nil then
						local itemName = item:GetName();
					
						if itemName == k then
							bFound = true;
							
							--**v Control of all data v**
							local BITTCtr = Turbine.UI.Control();
							BITTCtr:SetParent( BITTListBox );
							BITTCtr:SetSize( BITTListBox:GetWidth(), 35 );
							BITTCtr:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
							--BITTCtr:SetBackColor( Color["red"] ); -- Debug purpose
							--**^
	
							-- Item Background/Underlay/Shadow/Image
							local BITTitemBG = Turbine.UI.Control();
							BITTitemBG:SetParent( BITTCtr );
							BITTitemBG:SetSize( 32, 32 );
							BITTitemBG:SetPosition( 0, 2 );
							BITTitemBG:SetBackground(ITL[i][itemName].B);
							BITTitemBG:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		
							local BITTitemU = Turbine.UI.Control();
							BITTitemU:SetParent( BITTCtr );
							BITTitemU:SetSize( 32, 32 );
							BITTitemU:SetPosition( 0, 2 );
							BITTitemU:SetBackground(ITL[i][itemName].U);
							BITTitemU:SetBlendMode( Turbine.UI.BlendMode.Overlay );

							local BITTitemS = Turbine.UI.Control();
							BITTitemS:SetParent( BITTCtr );
							BITTitemS:SetSize( 32, 32 );
							BITTitemS:SetPosition( 0, 2 );
							BITTitemS:SetBackground(ITL[i][itemName].S);
							BITTitemS:SetBlendMode( Turbine.UI.BlendMode.Overlay );

							local BITTitem = Turbine.UI.Control();
							BITTitem:SetParent( BITTCtr );
							BITTitem:SetSize( 32, 32 );
							BITTitem:SetPosition( 0, 2 );
							BITTitem:SetBackground(ITL[i][itemName].I);
							BITTitem:SetBlendMode( Turbine.UI.BlendMode.Overlay );

							BITTListBox:AddItem( BITTCtr );
							BITTListBox:SetHeight( BITTPosY );

							-- Item Quantity
							itemQTE = Turbine.UI.Label();
							itemQTE:SetParent( BITTCtr );
							itemQTE:SetSize( 32, 15 );
							itemQTE:SetPosition( -4, 16 );
							itemQTE:SetFont( Turbine.UI.Lotro.Font.Verdana12 );
							itemQTE:SetFontStyle( Turbine.UI.FontStyle.Outline );
							itemQTE:SetOutlineColor( Color["black"] );
							itemQTE:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
							itemQTE:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
							itemQTE:SetForeColor( Color["nicegold"] );
							--BITTItemTot = BITTItemTot + item:GetQuantity();
							--itemQTE:SetText( BITTItemTot );

							--Check the rest of bag for same item (in case user as multiple stack
							for ii = i+1, size do
								local sameitem = backpack:GetItem( ii );
			
								if sameitem ~= nil then
									if sameitem:GetName() == k then
										BITTItemTot = BITTItemTot + sameitem:GetQuantity();
										itemQTE:SetText( BITTItemTot );
									end
								end
							end
							--
							--itemQTE:SetText( "9999" ); -- Debuf purpose

							-- Item name
							itemsLbl = Turbine.UI.Label();
							itemsLbl:SetParent( BITTCtr );
							itemsLbl:SetSize( BITTListBox:GetWidth() - 35, 33 );
							itemsLbl:SetPosition( 37, 2 );
							itemsLbl:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
							itemsLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
							itemsLbl:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
							itemsLbl:SetForeColor( Color["white"] );
							itemsLbl:SetText( itemName );
		
							BITTPosY = BITTPosY + 35;
						end
						if bFound then break end
					end
				end
			end
		end
	end

	BITTListBox:SetHeight( BITTPosY );
end